CoreUI ONE — 250+ PRO components and 25+ admin templates for React, Angular, Vue, Bootstrap and Next.js, plus Data Grid, Scheduler, 4,300+ PRO icons and the Next.js boilerplate. One license. → See what you get

How to Add a Bootstrap Modal in React Without Breaking React – The CoreUI Way

React Bootstrap Modal

If you’re building a React application and want to use a Bootstrap-style modal, you have options. You can rely on Bootstrap’s vanilla JavaScript, use a third-party component, or—more idiomatically—you can integrate a modal the “React way”: declarative, controlled, and accessible.

In this guide, I’ll show you how to do it properly using CoreUI for React — a component library that’s 100% compatible with Bootstrap styling but built entirely for React.

Table of Contents

Speed up your responsive apps and websites with fully-featured, ready-to-use open-source admin panel templates—free to use and built for efficiency.



👤 Who is this for?

This tutorial is for you if:

  • You’re using React with Bootstrap for an admin panel, dashboard, or web app.
  • You want full control over modal state (open/close via useState).
  • You care about accessibility, keyboard interaction, focus trap.
  • You want to avoid using data-bs-* or new bootstrap.Modal(...).

⚠️ Why Bootstrap Modal (even in v5+) is not React-friendly

Although Bootstrap 5+ no longer requires jQuery (🎉), it still manages the DOM imperatively. That doesn’t play well with React’s declarative lifecycle.

Problem Why It’s an Issue in React
Direct DOM manipulation Conflicts with React’s virtual DOM.
Imperative instantiation Requires calling JS constructors (new bootstrap.Modal(...)).
Uncontrolled UI Can’t tie modal visibility to React state easily.
Data attributes (data-bs-*) Not idiomatic or composable in React.

✅ The Solution: CModal from CoreUI for React

CoreUI for React solves this by offering prebuilt, Bootstrap-compatible components with React-friendly APIs:

  • Full control via visible, onClose, and other props.
  • Bootstrap 5+ styling and classes out of the box.
  • No jQuery, no DOM hacking.
  • Built-in support for accessibility, keyboard controls, backdrop, centering, fullscreen, and more.

⚙️ Example: Modal with a user creation form

import React, { useState } from 'react'
import {
  CButton,
  CModal,
  CModalHeader,
  CModalTitle,
  CModalBody,
  CModalFooter,
  CFormInput
} from '@coreui/react'

const AddUserModal = () => {
  const [visible, setVisible] = useState(false)

  return (
    <>
      <CButton color="primary" onClick={() => setVisible(true)}>
        Add User
      </CButton>

      <CModal visible={visible} onClose={() => setVisible(false)}>
        <CModalHeader>
          <CModalTitle>Add New User</CModalTitle>
        </CModalHeader>
        <CModalBody>
          <CFormInput type="text" label="Full Name" />
          <CFormInput type="email" label="Email" className="mt-2" />
        </CModalBody>
        <CModalFooter>
          <CButton color="secondary" onClick={() => setVisible(false)}>
            Cancel
          </CButton>
          <CButton color="primary">Save</CButton>
        </CModalFooter>
      </CModal>
    </>
  )
}

export default AddUserModal

✅ Modal behavior you get out of the box

Feature ✅ Supported
Controlled visibility via React state ✅
ESC key support ✅
Focus trap & keyboard nav ✅
Accessible attributes (role="dialog", ARIA) ✅
Works with Next.js / SSR ✅
Responsive / fullscreen / scrollable ✅
Dark mode compatible ✅ (via Bootstrap theme)

🤔 When NOT to use CModal

You might prefer something else if:

  • You’re using Headless UI or Framer Motion for custom UX.
  • You need custom modal styling outside of Bootstrap.
  • You’re building a fully animated SPA with no Bootstrap classes.

But if you want Bootstrap styling + React state control, this is your go-to option.


❓ Common questions

Can I use this in Next.js?

Yes — CoreUI components are SSR-compatible.

Does this rely on Bootstrap 5 styles?

Yes — all components follow Bootstrap 5+ classes and layout.

Do I need to install Bootstrap separately?

No — CoreUI includes all necessary CSS via its package.


🧠 Why it matters

Using CModal gives you:

  • A predictable, declarative UI pattern.
  • Seamless Bootstrap look without imperative code.
  • Clean React integration that scales well.
  • No hacks or workarounds for modal behavior.

➕ Next steps


Build faster without reinventing Bootstrap in React. CoreUI for React gives you the components you need, with full Bootstrap compatibility and React power.

About the Author

Subscribe to our newsletter
Get early information about new products, product updates and blog posts.

CoreUI ONE — 250+ PRO components and 25+ admin templates for React, Angular, Vue, Bootstrap and Next.js, plus Data Grid, Scheduler, 4,300+ PRO icons and the Next.js boilerplate. One license. → See what you get

How to Use Bootstrap Modal in Vue 3 – Clean Integration with CoreUI

Angular Bootstrap Modal

Modals are a key part of modern UI — used for confirmations, forms, alerts, and more. If you’re building an Angular application with Bootstrap 5 styles, you might wonder how to implement modals without relying on jQuery or manual DOM manipulation.

Table of Contents

Speed up your responsive apps and websites with fully-featured, ready-to-use open-source admin panel templates—free to use and built for efficiency.


In this article, you’ll learn how to use a Bootstrap-style modal in Angular with CModal from CoreUI for Angular. It’s fully component-based, reactive, and ready to use in Angular apps — without hacks, boilerplate, or data-bs-* attributes.


👤 Who is this for?

This article is perfect for Angular developers who:

  • Use Bootstrap 5 or CoreUI in their Angular projects.
  • Want to use modals declaratively via Angular components.
  • Prefer reactive patterns over manual Bootstrap JS handling.
  • Need keyboard accessibility, SSR compatibility, and mobile responsiveness.

🧨 Why Native Bootstrap JS Doesn’t Work Well in Angular

Bootstrap’s own modals are JavaScript-powered and imperatively controlled:

const modal = new bootstrap.Modal(document.getElementById('modal'))
modal.show()

That doesn’t fit Angular’s reactive, declarative structure. Problems include:

Issue Why It’s a Problem in Angular
DOM-based instantiation Angular discourages direct DOM manipulation
Manual lifecycle control Risk of memory leaks or UI bugs
No TypeScript integration No types, no inputs/outputs
Breaks with Angular SSR Cannot run cleanly on the server

✅ The Angular Way: Use CModal from CoreUI

With CModal, you get:

  • Bootstrap 5 styling out of the box
  • Angular component with visible input and close event
  • Proper focus trap and ESC key behavior
  • Slot-based layout for header, body, footer
  • Full accessibility and responsive behavior

⚙️ Example: Modal with Form Content

app.component.ts

import { Component } from '@angular/core'

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
})
export class AppComponent {
  visible = false

  openModal() {
    this.visible = true
  }

  closeModal() {
    this.visible = false
  }
}

app.component.html

<c-button color="primary" (click)="openModal()">Open Modal</c-button>

<c-modal [visible]="visible" (close)="closeModal()">
  <c-modal-header>
    <c-modal-title>Add New Item</c-modal-title>
  </c-modal-header>

  <c-modal-body>
    <c-form-input label="Item Name"></c-form-input>
    <c-form-input label="Price" type="number" class="mt-2"></c-form-input>
  </c-modal-body>

  <c-modal-footer>
    <c-button color="secondary" (click)="closeModal()">Cancel</c-button>
    <c-button color="primary">Save</c-button>
  </c-modal-footer>
</c-modal>

🧪 Features You Get Automatically

Feature ✅ Supported
Bootstrap 5 styling ✅
Controlled via [visible] ✅
Emits (close) event ✅
Focus trap & ESC key ✅
ARIA roles ✅
SSR-safe ✅
Dark mode compatible ✅
Responsive / fullscreen ✅ via props

🔧 Common Props

You can use the following props on <c-modal>:

  • scrollable – allow scrolling inside the modal body
  • centered – vertically center the modal
  • fullscreen – make the modal full screen
  • size="sm" | "lg" | "xl" – change modal width

Example:

<c-modal [visible]="visible" centered fullscreen="md-down" size="lg">...</c-modal>

❓ FAQ

Can I use CoreUI modal in Angular with SSR (e.g., Angular Universal)?

Yes — the modal is rendered declaratively and doesn’t require document or window.

Is the modal accessible?

Yes — focus is managed, ARIA roles are used, ESC key closes it.

Does it support animations?

Yes — fade transitions are built-in, matching Bootstrap’s default behavior.


🧠 Why this matters

You don’t want to mix imperative Bootstrap code into your Angular app. That leads to:

  • Component lifecycle issues,
  • Inconsistent state,
  • Broken TypeScript support.

With CModal, you get a real Angular component, not a wrapper — with complete control, styling, and flexibility built in.


➕ Explore More


Use Bootstrap-styled modals the Angular way — fully declarative, accessible, and ready for production with CoreUI for Angular.

About the Author

Subscribe to our newsletter
Get early information about new products, product updates and blog posts.

CoreUI ONE — 250+ PRO components and 25+ admin templates for React, Angular, Vue, Bootstrap and Next.js, plus Data Grid, Scheduler, 4,300+ PRO icons and the Next.js boilerplate. One license. → See what you get

How to Use Bootstrap Modal in Vue 3 – Clean Integration with CoreUI

Vue Bootstrap Modal

Modals are essential in modern interfaces, whether you’re confirming destructive actions, displaying forms, or showing dynamic content. If you’re using Vue 3 with Bootstrap styles, you might wonder: what’s the cleanest and most idiomatic way to use a modal?

Table of Contents

Speed up your responsive apps and websites with fully-featured, ready-to-use open-source admin panel templates—free to use and built for efficiency.


In this guide, you’ll learn how to implement a Bootstrap-style modal in Vue 3 using CModal from CoreUI for Vue — declaratively, accessibly, and with full control over behavior and styling.


👤 Who is this for?

You’ll benefit from this article if:

  • You’re building a Vue 3 app styled with Bootstrap 5 or CoreUI.
  • You want a declarative, reactive modal component.
  • You care about keyboard accessibility, mobile UX, and SSR compatibility.
  • You’re looking for a ready-to-use modal that just works, with no imperative DOM hacks.

🧨 Why Bootstrap’s Native Modal Is Not Vue-Friendly

Bootstrap’s own modal JS API requires you to manually instantiate and control modals through the DOM:

const modal = new bootstrap.Modal(document.getElementById('modal'))
modal.show()

That doesn’t work well in Vue, which favors declarative templates, reactive state, and lifecycle-aware components. You risk:

  • DOM mismatches,
  • memory leaks,
  • broken behavior on re-renders or SSR.

✅ Use CModal – The Vue Way

With CModal from CoreUI for Vue, you get:

  • Full Bootstrap 5 styling out of the box,
  • Controlled visibility through Vue’s reactivity system,
  • Built-in support for ESC key, backdrop, and focus trap,
  • Clean syntax with visible prop and @close event,
  • Seamless SSR/Nuxt compatibility.

⚙️ Example: Modal With Form Content

<template>
  <div>
    <CButton color="primary" @click="showModal = true">
      Open Modal
    </CButton>

    <CModal :visible="showModal" @close="showModal = false">
      <CModalHeader>
        <CModalTitle>Add New Item</CModalTitle>
      </CModalHeader>
      <CModalBody>
        <CFormInput label="Item Name" />
        <CFormInput label="Price" type="number" class="mt-2" />
      </CModalBody>
      <CModalFooter>
        <CButton color="secondary" @click="showModal = false">Cancel</CButton>
        <CButton color="primary">Save</CButton>
      </CModalFooter>
    </CModal>
  </div>
</template>

<script setup>
import {
  CModal,
  CModalHeader,
  CModalTitle,
  CModalBody,
  CModalFooter,
  CButton,
  CFormInput
} from '@coreui/vue'
import { ref } from 'vue'

const showModal = ref(false)
</script>

🧪 Features You Get by Default

Feature ✅ Included
Bootstrap 5+ styling ✅
Declarative control ✅
ESC key & focus trap ✅
ARIA attributes ✅
Fullscreen, centered, scrollable options ✅
SSR/Nuxt 3 compatibility ✅

🔄 Optional Enhancements

You can enhance behavior with these props:

  • scrollable: allow body scroll inside modal
  • fullscreen: make the modal cover the full screen
  • centered: vertically center the modal
  • size="lg" / "sm": control modal width
<CModal :visible="showModal" centered scrollable size="lg">

❓ FAQ

Can I use this in Nuxt 3?

Yes — CoreUI components work in SSR setups.

Does it include fade transitions and keyboard support?

Yes — Bootstrap-style fade animations and ESC key handling are built in.

Can I nest other components inside the modal?

Absolutely — modals accept any slot content.


➕ Learn More


Build better UI dialogs in Vue with the power of Bootstrap styling and Vue 3 reactivity — no DOM hacks, no boilerplate, just clean logic.

About the Author

Subscribe to our newsletter
Get early information about new products, product updates and blog posts.